import javax.microedition.lcdui.*;
import java.util.*;

public class ElementList extends List implements CommandListener { 
 midlet  browser;
 Displayable parent;
 Vector      elements;
 XMLElement  element;

 ElementList (XMLElement element, midlet browser, Displayable parent) { 
  this (element.getName(), element.getItems(), browser, parent);
  this.element = element;
  addCommand(browser.SEARCH_CMD);        
 }

 ElementList (String title, Vector elements, midlet browser, Displayable parent) { 
  super (title, IMPLICIT);
  this.elements = elements;
  this.parent = parent;
  this.browser = browser;
  for (int i = 0, n = elements.size(); i < n; i++) { 
   XMLElement elem = (XMLElement)elements.elementAt(i);
   String itemName;
   XMLAttribute name = elem.getAttribute(browser.locale.getResource("Name"));
   if (name != null) { itemName = name.getValue(); } 
   else { itemName = elem.getName(); }
   append (itemName, browser.itemImage);
  }
  if (title.compareTo(browser.locale.getResource("Search result"))==0)
   setTitle (title+" ("+elements.size()+")");
  setCommandListener (this);
  if (parent == null) { addCommand(browser.QUIT_CMD); }
  else { addCommand(browser.BACK_CMD); }
  Display.getDisplay(browser).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) {
  if (c == browser.SEARCH_CMD) { 
   new SearchBox(element, browser, this);
  } 
  else if (c == browser.BACK_CMD) { 
   Display.getDisplay(browser).setCurrent(parent);
  } 
  else if (c == browser.QUIT_CMD) { 
   browser.quit();
  } 
  else { 
   int i = getSelectedIndex();
   if (i >= 0) { 
    browser.showElement((XMLElement)elements.elementAt(i), this);
   }
  }
 }

}